import { forwardRef, useEffect, useRef } from 'react';
import cx from 'classnames';
import PropTypes from 'prop-types';
import useMergeRefs from '@s-ui/react-hooks/lib/useMergeRefs';
import { CLASS_TAB, CLASS_TAB_ACTIVE, CLASS_TAB_COUNT, CLASS_TAB_DISABLED, CLASS_TAB_ICON } from './config.js';
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
var MoleculeTab = /*#__PURE__*/forwardRef(function (_ref, forwardedRef) {
  var _cx;
  var active = _ref.active,
    _ref$autoScrollIntoVi = _ref.autoScrollIntoView,
    autoScrollIntoView = _ref$autoScrollIntoVi === void 0 ? true : _ref$autoScrollIntoVi,
    count = _ref.count,
    disabled = _ref.disabled,
    icon = _ref.icon,
    _ref$id = _ref.id,
    id = _ref$id === void 0 ? 'molecule-tab-content' : _ref$id,
    isIntersecting = _ref.isIntersecting,
    label = _ref.label,
    numTab = _ref.numTab,
    onChange = _ref.onChange;
  var innerRef = useRef();
  var handleChange = function handleChange(ev) {
    !disabled && onChange(ev, {
      numTab: numTab
    });
  };
  useEffect(function () {
    if (autoScrollIntoView && active && isIntersecting) {
      innerRef.current.scrollIntoView({
        behavior: 'smooth',
        block: 'nearest',
        inline: 'start'
      });
    }
  }, [autoScrollIntoView, active, isIntersecting, innerRef]);
  var className = cx(CLASS_TAB, (_cx = {}, _cx[CLASS_TAB_ACTIVE] = active, _cx[CLASS_TAB_DISABLED] = disabled, _cx));
  return /*#__PURE__*/_jsxs("li", {
    className: className,
    onClick: handleChange,
    ref: useMergeRefs(innerRef, forwardedRef),
    role: "tab",
    "aria-selected": active,
    "aria-controls": id + "-" + numTab,
    children: [icon && /*#__PURE__*/_jsx("span", {
      className: CLASS_TAB_ICON,
      children: icon
    }), !isNaN(count) && /*#__PURE__*/_jsx("span", {
      className: CLASS_TAB_COUNT,
      children: count
    }), /*#__PURE__*/_jsx("span", {
      children: label
    })]
  });
});
export default MoleculeTab;